/*****************************************************************************
 * This software is distributed under the terms of the General Public License.
 *
 * Program :   kastrolog 5.4 beta 3
 * Authors : see the AUTHORS file
 * E-Mail  : Llyra@altavista.com
*****************************************************************************/ 


#include <kapp.h>
#include "./kmenubar.h"
#include <kpopmenu.h>
#include <ktoolbar.h>
#include <kiconloader.h>

#define LASTICON 7

//enum menus {file, edit};
enum ChartMode { Comparison, Synastry, Composite, Time_Space , Date_Diff, Biorhythm, Transit_Natal, Progressed_Natal};
enum ChartType { List, Wheel, Grid, Aspect, MidPoint, Horizon, Orbit, Sector, Calendar, Influence, AstroGraph, Ephemeris, Arabic, Rising, Transit, Progress };
enum GraphType { Map, Globe, Polar };
enum nScaleType { Small, Medium, Large, Huge };
enum JRateType { Seconds, Minutes, Hours, Days, Months, Years, Decades, Centuries, Millenia };
enum JFact { Unit_1, Unit_2, Unit_3, Unit_4, Unit_5, Unit_6, Unit_7, Unit_8, Unit_9 };

struct icons
{
  char *s, *tip;
  int id;
};

class AstroMenu : public KMenuBar
{
  Q_OBJECT

 public:
  
  AstroMenu(QWidget *parent);
  
public slots:

  void menuslot(int);
  void iconsslot(int);
  void nbsslot(int);
  void unitsslot(int);

 private:
  
  void Toggle(int);
  void ToggleChart(ChartMode);
  void ToggleType(ChartType);
  void ToggleGraph(GraphType);
  void ToggleHousSys();
  void TogglenScale(int);
  void ToggleJRate(JRateType);
  void ToggleJFact(JFact, int);
  bool minors;
 
};









